
package de.codedo.conflicteditor.gui;

import de.codedo.conflicteditor.Difference;

import java.util.ArrayList;
import java.util.List;

import javax.swing.table.AbstractTableModel;

public class DifferenceTableModel extends AbstractTableModel
{
    public static final String[] COLUMN_NAMES = { "Key", "Current value", "Old value" };

    private List<Difference> _differences;

    public DifferenceTableModel(List<Difference> differences)
    {
        super();
        _differences = differences;
    }

    public DifferenceTableModel()
    {
        this(new ArrayList<Difference>());
    }

    @Override
    public int getColumnCount()
    {
        return 3;
    }

    @Override
    public int getRowCount()
    {
        return _differences.size();
    }

    @Override
    public Object getValueAt(int rowIndex, int columnIndex)
    {
        Difference diff = _differences.get(rowIndex);
        switch (columnIndex)
        {
            case 0 :
                return diff.key;

            case 1 :
                return diff.currentValue;

            case 2 :
                return diff.otherValue;
        }

        throw new IllegalStateException("invalid column index: " + columnIndex);
    }

    @Override
    public String getColumnName(int column)
    {
        return COLUMN_NAMES[column];
    }
}
