
package de.codedo.conflicteditor.gui;

import java.awt.Component;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.JOptionPane;

public class ExceptionHandlingActionListener extends Object implements ActionListener
{
    private Executable<ActionEvent> _executable;

    public ExceptionHandlingActionListener(Executable<ActionEvent> executable)
    {
        super();
        _executable = executable;
    }

    @Override
    public void actionPerformed(ActionEvent event)
    {
        try
        {
            _executable.execute(event);
        }
        catch (Exception ex)
        {
            String stacktrace = ExceptionUtil.toString(ex);
            Component source = (Component)event.getSource();
            JOptionPane.showMessageDialog(source, stacktrace, "Error", JOptionPane.ERROR_MESSAGE);
        }
    }
}
